#
# spec file for package stack
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name stack
%bcond_with tests
Name:           %{pkg_name}
Version:        1.5.0
Release:        lp150.1.25
Summary:        The Haskell Tool Stack
License:        BSD-3-Clause
Group:          Development/Languages/Other
Url:            https://hackage.haskell.org/package/%{name}
Source0:        https://hackage.haskell.org/package/%{name}-%{version}/%{name}-%{version}.tar.gz
Source1:        https://hackage.haskell.org/package/%{name}-%{version}/revision/1.cabal#/%{name}.cabal
BuildRequires:  chrpath
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-aeson-devel
BuildRequires:  ghc-annotated-wl-pprint-devel
BuildRequires:  ghc-ansi-terminal-devel
BuildRequires:  ghc-async-devel
BuildRequires:  ghc-attoparsec-devel
BuildRequires:  ghc-base-compat-devel
BuildRequires:  ghc-base64-bytestring-devel
BuildRequires:  ghc-binary-devel
BuildRequires:  ghc-binary-tagged-devel
BuildRequires:  ghc-blaze-builder-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-clock-devel
BuildRequires:  ghc-conduit-devel
BuildRequires:  ghc-conduit-extra-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-cryptonite-conduit-devel
BuildRequires:  ghc-cryptonite-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-echo-devel
BuildRequires:  ghc-either-devel
BuildRequires:  ghc-errors-devel
BuildRequires:  ghc-exceptions-devel
BuildRequires:  ghc-extra-devel
BuildRequires:  ghc-fast-logger-devel
BuildRequires:  ghc-file-embed-devel
BuildRequires:  ghc-filelock-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-fsnotify-devel
BuildRequires:  ghc-generic-deriving-devel
BuildRequires:  ghc-gitrev-devel
BuildRequires:  ghc-hackage-security-devel
BuildRequires:  ghc-hashable-devel
BuildRequires:  ghc-hastache-devel
BuildRequires:  ghc-hpack-devel
BuildRequires:  ghc-hpc-devel
BuildRequires:  ghc-http-client-devel
BuildRequires:  ghc-http-client-tls-devel
BuildRequires:  ghc-http-conduit-devel
BuildRequires:  ghc-http-types-devel
BuildRequires:  ghc-lifted-async-devel
BuildRequires:  ghc-lifted-base-devel
BuildRequires:  ghc-memory-devel
BuildRequires:  ghc-microlens-devel
BuildRequires:  ghc-microlens-mtl-devel
BuildRequires:  ghc-mintty-devel
BuildRequires:  ghc-monad-control-devel
BuildRequires:  ghc-monad-logger-devel
BuildRequires:  ghc-monad-unlift-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-network-uri-devel
BuildRequires:  ghc-open-browser-devel
BuildRequires:  ghc-optparse-applicative-devel
BuildRequires:  ghc-optparse-simple-devel
BuildRequires:  ghc-path-devel
BuildRequires:  ghc-path-io-devel
BuildRequires:  ghc-persistent-devel
BuildRequires:  ghc-persistent-sqlite-devel
BuildRequires:  ghc-persistent-template-devel
BuildRequires:  ghc-pid1-devel
BuildRequires:  ghc-pretty-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-project-template-devel
BuildRequires:  ghc-regex-applicative-text-devel
BuildRequires:  ghc-resourcet-devel
BuildRequires:  ghc-retry-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-safe-devel
BuildRequires:  ghc-safe-exceptions-devel
BuildRequires:  ghc-semigroups-devel
BuildRequires:  ghc-split-devel
BuildRequires:  ghc-stm-devel
BuildRequires:  ghc-store-core-devel
BuildRequires:  ghc-store-devel
BuildRequires:  ghc-streaming-commons-devel
BuildRequires:  ghc-tar-devel
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-temporary-devel
BuildRequires:  ghc-text-binary-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-text-metrics-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-tls-devel
BuildRequires:  ghc-transformers-base-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-unicode-transforms-devel
BuildRequires:  ghc-unix-compat-devel
BuildRequires:  ghc-unix-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-vector-binary-instances-devel
BuildRequires:  ghc-vector-devel
BuildRequires:  ghc-yaml-devel
BuildRequires:  ghc-zip-archive-devel
BuildRequires:  ghc-zlib-devel
Suggests:       docker
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if %{with tests}
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-hspec-devel
BuildRequires:  ghc-mono-traversable-devel
BuildRequires:  ghc-neat-interpolation-devel
BuildRequires:  ghc-smallcheck-devel
BuildRequires:  ghc-th-reify-many-devel
%endif

%description
Stack is a cross-platform program for developing Haskell projects. It is aimed
at Haskellers both new and experienced. It features:

* Installing GHC automatically, in an isolated location.
* Installing packages needed for your project.
* Building your project.
* Testing your project.
* Benchmarking your project.

%package -n ghc-%{name}
Summary:        Haskell %{name} library
Group:          System/Libraries

%description -n ghc-%{name}
This package provides the Haskell %{name} shared library.

%package -n ghc-%{name}-devel
Summary:        Haskell %{name} library development files
Group:          Development/Libraries/Other
Requires:       ghc-%{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description -n ghc-%{name}-devel
This package provides the Haskell %{name} library development files.

%prep
%setup -q
cp -p %{SOURCE1} %{name}.cabal

%build
%ghc_lib_build

%install
%ghc_lib_install
%ghc_fix_rpath %{pkg_name}-%{version}

%check
%cabal_test

%post -n ghc-%{name}-devel
%ghc_pkg_recache

%postun -n ghc-%{name}-devel
%ghc_pkg_recache

%files
%defattr(-,root,root,-)
%doc LICENSE
%doc ChangeLog.md README.md doc
%{_bindir}/%{name}

%files -n ghc-%{name} -f ghc-%{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files -n ghc-%{name}-devel -f ghc-%{name}-devel.files
%defattr(-,root,root,-)
%doc ChangeLog.md README.md doc

%changelog
* Wed Jul 26 2017 psimons@suse.com
- Update to version 1.5.0 revision 1.
* Fri Apr 21 2017 psimons@suse.com
- Update to version 1.4.0 revision 4 with cabal2obs.
* Thu Mar 16 2017 psimons@suse.com
- Update to version 1.3.2 revision 2 with cabal2obs.
* Wed Aug 24 2016 psimons@suse.com
- Update to version 1.1.2 revision 8 with cabal2obs.
* Wed Aug 17 2016 psimons@suse.com
- Update to version 1.1.2 revision 7 with cabal2obs.
* Sat Jul 16 2016 psimons@suse.com
- Update to version 1.1.2 revision 6 with cabal2obs.
* Sun Jul 10 2016 psimons@suse.com
- Update to version 1.1.2 revision 5 with cabal2obs.
* Mon May 23 2016 mimi.vx@gmail.com
- update to 1.1.2
  * Extensible custom snapshots implemented. These allow you to define snapshots
    which extend other snapshots
  * Local file custom snapshots can now be safely updated without changing their
  name. Remote custom snapshots should still be treated as immutable.
  * stack path --compiler was added in the last release, to yield a path to
  the compiler. Unfortunately, --compiler is a global option that is useful
  to use with stack path. The same functionality is now provided by
  stack path --compiler-exe.
  * For packages specified in terms of a git or hg repo, the hash used in the location
  has changed. This means that existing downloads from older stack versions
  won't be used. This is a side-effect of the fix to #2133
  * stack upgrade no longer pays attention to local stack.yaml files, just the
  global config and CLI options.
  * stack ghci now uses :add instead of :load, making it potentially work better
  with user scripts.
  * Grab Cabal files via Git SHA to avoid regressions from Hackage revisions
  * Custom snapshots now support ghc-options.
  * Package git repos are now re-used rather than re-cloned.
  * DESTDIR is filtered from environment when installing GHC.
  * stack haddock now supports --hadock-arguments.
  * Signing: warn if GPG_TTY is not set as per man gpg-agent
  * Now ignore project config when doing stack init or stack new.
  * Packages specified by git repo can now have submodules.
  * Fix of hackage index fetch retry.
  * HPack now picks up changes to filesystem other than package.yaml.
  * "stack solver" no longer suggests --omit-packages.
  * Fixed an issue with building Cabal's Setup.hs.
  * Package dirtiness now pays attention to deleted files.
  * stack ghci now uses extra-lib-dirs and extra-include-dirs.
  * Relative paths outside of source dir added via qAddDependentFile are now
  checked for dirtiness.
  * Signing: always use --with-fingerprints
* Thu May  5 2016 mimi.vx@gmail.com
- update to 1.1.0
- cleanup BuildRequires
- for complete changelog https://hackage.haskell.org/package/stack-1.1.0/changelog
  * Package tarballs would fail to unpack.
  * Fixed errant warnings about missing modules, after deleted and removed from
  cabal file
  * Now considers a package to dirty when the hpack file is changed
  * allow-newer: true now causes --exact-configuration to be passed to Cabal.
  * stack solver no longer fails with InvalidRelFile for relative package paths
  including ...
  * Ignore emacs lock files when finding .cabal
  * Use lenient UTF-8 decode for build output
  * Clear index cache whenever index updated
  * Fix: Building a container image drops a .stack-work dir in the current working
  (sub)directory
  * Fix: Rebuilding when disabling profiling
* Sat Apr  9 2016 mimi.vx@gmail.com
- update to 1.0.4.3
  * Don't delete contents of ~/.ssh when using stack clean --full with Docker enabled
* Fri Mar 25 2016 mimi.vx@gmail.com
- update to 1.0.4.2
  * Build with path-io-1.0.0.
  * Fixes build with aeson-0.11.0.0.
  * Major changes:
  + Some notable changes in stack init:
  Overall it should now be able to initialize almost all existing cabal
  packages out of the box as long as the package itself is consistently
  defined.
  Choose the best possible snapshot and add extra dependencies on top of
  a snapshot resolver rather than a compiler resolver
  Automatically omit a package (--omit-packages) when it is compiler
  incompatible or when there are packages with conflicting dependency
  requirements
  Some more changes for a better user experience. Please refer to the doc
  guide for details.
  Add support for hpack, alternative package description format
  * Other enhancements:
  + Docker: pass ~/.ssh and SSH auth socket into container, so that git repos work
  + Docker: strip suffix from docker --version.
  + Docker: pass USER and PWD environment bariables into container.
  + On each run, stack will test the stack root directory (~/.stack), and
  the project and package work directories (.stack-work) for whether they are
  owned by the current user and abort if they are not. This precaution can be
  disabled with the --allow-different-user flag or allow-different-user option
  in the global config.
  + Added stack clean --full option for full working dir cleanup.
  + YAML config: support Zip archives.
  + Redownload build plan if parsing fails
  + Give mustache templates access to a 'year' tag
  + Have "stack ghci" warn about module name aliasing.
  + Add "stack ghci --load-local-deps".
  + Build Setup.hs with -rtsopts
  + stack init accepts a list of directories.
  +Add flag infos to DependencyPlanFailuresd
  + stack new --bare complains for overwrites, and add --force option
  * Bug fixes:
  + Previously, stack ghci would fail with cannot satisfy -package-id when the
  implicit build step changes the package key of some dependency.
  + Fix: Building with ghcjs: "ghc-pkg: Prelude.chr: bad argument: 2980338"
  + Fix running test / bench with --profile / --trace.
  + Fix: build progress counter is no longer visible
  + Use "-RTS" w/ profiling to allow extra args
  + Fix withUnpackedTarball7z to find name of srcDir after unpacking
  + Add space before auto-generated bench opts (makes profiling options work
  uniformly for applications and benchmark suites)
  + Don't try to find plugin if it resembles flag.
  + Setup.hs changes cause package dirtiness
  + Send "stack templates" output to stdout
* Wed Jan 20 2016 mimi.vx@gmail.com
- update to 1.0.2
  * stack init and solver overhaul
  * Disable locale/codepage hacks when GHC >=7.10.3
  * Specify multiple images to build for stack image container docs
  * Specify which executables to include in images for stack image container docs
  * Docker: pass supplemantary groups and umask into container
  * If git fetch fails wipe the directory and try again from scratch
  * Warn if newly installed executables won't be available on the PATH
  * stack.yaml: for stack image container, specify multiple images to generate, and
  which executables should be added to those images
  * GHCI: add interactive Main selection
  * Care less about the particular name of a GHCJS sdist folder
  * Unified Enable/disable help messaging
  * Bug fixes:
  + Don't share precompiled packages between GHC/platform variants and Docker
  + Properly redownload corrupted downloads with the correct file size. Mailing list discussion
  + Gracefully handle invalid paths in error/warning messages
  + Fix: Stack does not allow using an external package from ghci
  + Disable ambiguous global '--resolver' option for 'stack init'
  + Obey --no-nix flag
  + Fix: GHCJS Execute.hs: Non-exhaustive patterns in lambda
  + Send file-watch and sticky logger messages to stderr
  + Use globaldb path for querying Cabal version
* Fri Dec 25 2015 mimi.vx@gmail.com
- update to 1.0.0
  * Enhancements:
  + Added flag --profile flag: passed with stack build, it will enable profiling,
  and for --bench and --test it will generate a profiling report by passing
  +RTS -p to the executable(s). Great for using like stack build --bench
  - -profile (remember that enabling profile will slow down your benchmarks by
  >4x). Run stack build --bench again to disable the profiling and get proper
  speeds
  + Added flag --trace flag: just like --profile, it enables profiling, but
  instead of generating a report for --bench and --test, prints out a stack
  trace on exception. Great for using like stack build --test --trace
  + Make verbosity silent by default in script interpreter mode
  + Show a message when resetting git commit fails
  + Improve Unicode handling in project/package names
  + Fix ambiguity between a stack command and a filename to execute (prefer stack
  subcommands)
  + Support multi line interpreter directive comments
  + Handle space separated pids in ghc-pkg dump (for GHC HEAD)
  + Add ghci --no-package-hiding option
  + stack new can download templates from URL
  * Bug fixes:
  + Nix: stack exec options are passed properly to the stack sub process
  + Nix: specifying a shell-file works in any current working directory
  + Nix: use --resolver argument
  + Docker: fix missing image message and '--docker-auto-pull'
  + No HTML escaping for "stack new" template params
  + Set permissions for generated .ghci script
  + Restrict commands allowed in interpreter mode
  + stack ghci doesn't see preprocessed files for executables
  + All test suites run even when only one is requested
  + Edge cases in broken templates give odd errors
  + Fix test coverage bug on windows
* Tue Dec 15 2015 mimi.vx@gmail.com
- update to 0.1.10.1
- add suggest docker
- adjust bifunctors, aeson, semigroups constraints
  * stack image container did not actually build an image
* Mon Dec  7 2015 mimi.vx@gmail.com
- update to 0.1.10.0
  * Major changes:
  + Support for building inside a Nix-shell providing system dependencies
  + Add optional GPG signing on stack upload --sign or with stack sig sign ...
  * Other enhancements:
  + Print latest applicable version of packages on conflicts
  + Support for packages located in Mercurial repositories
  + Only run benchmarks specified as build targets
  + Support git-style executable fall-through (stack something executes
    stack-something if present)
  + GHCi now loads intermediate dependencies
  + --work-dir option for overriding .stack-work
  + Support detailed-0.9 tests
  + Docker: improved POSIX signal proxying to containers
  * Bug fixes:
  + Show absolute paths in error messages in multi-package builds
  + Docker-built binaries and libraries in different path
  + Docker: --resolver argument didn't effect selected image tag
  + GHCi: Spaces in filepaths caused module loading issues
  + GHCi: cpp-options in cabal files weren't used
  + Benchmarks couldn't be run independently of eachother
  + Send output of building setup to stderr
* Sun Nov 22 2015 mimi.vx@gmail.com
- update to 0.1.8.0
  * Major changes:
  + GHCJS can now be used with stackage snapshots via the new compiler field.
  + Docker integration works with non-FPComplete generated images
  * Other enhancements:
  + Added an allow-newer config option
  + When a Hackage revision invalidates a build plan in a snapshot, trust
  the snapshot
  + Added a stack config set resolver RESOLVER command.
  + stack hpc report command added, which generates reports for HPC tix files
  + stack ghci now accepts all the flags accepted by stack build.
  + stack ghci builds the project before launching GHCi. If the build fails,
  optimistically launch GHCi anyway. Use stack ghci --no-build option
  to disable
  + stack ghci now detects and warns about various circumstances where it is
  liable to fail.
  + Added require-docker-version configuration option
  + Packages will now usually be built along with their tests and benchmarks.
  + Relative local-bin-path paths will be relative to the project's root directory,
  not the current working directory.
  + stack clean now takes an optional [PACKAGE] argument for use in
  multi-package projects.
  + Ignore cabal_macros.h as a dependency
  + Pad timestamps and show local time in --verbose output
  + GHCi: Import all modules after loading them
  + Add subcommand aliases: repl for ghci, and runhaskell for runghc
  + Add typo recommendations for unknown package identifiers
  + Add stack path --local-hpc-root option
  + Overhaul dependencies' haddocks copying
  + Support for extra-package-dbs in 'stack ghci'
  + stack new disallows package names with "words" consisting solely of numbers
  + stack build --fast turns off optimizations
  * Bug fixes:
  + Fix: Haddocks not copied for dependencies
  + Fix: Global options did not work consistently after subcommand
  + Fix: 'stack ghci' doesn't notice that a module got deleted
  + Rebuild when cabal file is changed
  + Fix: Paths in GHC warnings not canonicalized, nor those for packages in
  subdirectories or outside the project root
  + Fix: unlisted files in tests and benchmarks trigger extraneous second build
* Sun Nov 15 2015 mimi.vx@gmail.com
- initial commit
